#include "stdafx.h"
#include "CodaLSock.h"
#include "CodaMsgList.h"
#include "ProcWatch.h"
#include "CodaStart.h"
#include "CodaStartDlg.h"

CCodaListenSocket::CCodaListenSocket ()
	: CSocket ()
{
	m_pMsgList = NULL;
}

BOOL CCodaListenSocket::Create (CCodaMsgList *p, UINT nPort /* = 9000 */)
{
	BOOL bOK = CSocket::Create(nPort, SOCK_DGRAM);
	ULONG ul = 1;
	if (bOK) {
		ioctlsocket (m_hSocket, FIONBIO, &ul);
		m_pMsgList = p;
	}
	return bOK;
}

void CCodaListenSocket::OnReceive (int nErrorCode)
{
	struct CodaMsg {
		DWORD	cm_dwType;
		CHAR	cm_buf[8000];
	} msg;
	int n;

	n = Receive (&msg, sizeof(msg));
	if (n < 0) {
		// error
		return;
	}
	n -= sizeof(DWORD);
	if (!m_pMsgList)
		return;

	switch (msg.cm_dwType) {
	case 0:
		m_pMsgList->addCodaRequest (msg.cm_buf, n);
		break;

	case 1:
		m_pMsgList->addCodaReply (msg.cm_buf, n);
		break;

	default:
		m_pMsgList->addOtherMsg (msg.cm_buf, n);
	}
}

